local addonInfo, privateVars = ...

if not EnKai then EnKai = {} end
if not EnKai.events then EnKai.events = {} end

EnKai.eventHandlers = {}

privateVars.events = { insecure = {} }

function EnKai.events.updateHandler()

	EnKai.coroutines.process ()
	EnKai.fx.process()
	EnKai.events.insecure()
	EnKai.uiGarbageCollector () -- missing SetName() on frames to fully build this

end

function EnKai.events.insecure()

	if Inspect.System.Secure() == true then return end
	
	for idx = 1, #privateVars.events.insecure, 1 do
		privateVars.events.insecure[idx]()
	end
	
	privateVars.events.insecure = {}

end

function EnKai.events.addInsecure(func)

	table.insert(privateVars.events.insecure, func)

end

function EnKai.internal.checkEvents (name, init)

	if EnKai.eventHandlers[name] == nil and init ~= false then
		EnKai.eventHandlers[name] = {}
		EnKai.events[name] = {}
	elseif init ~= false then
		EnKai.tools.error.display (addonInfo.identifier, string.format("Duplicate name '%s' found!", name), 1)
		return false
	end
	
	return true

end

Command.Event.Attach(Event.System.Update.Begin, EnKai.events.updateHandler, "EnKai.uiUpdateHandler")